dss = {};

dss.ajaxSyncRequest = function(surl, params) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?"

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        xmlHttp.open('GET', surl + paramString, false);
        xmlHttp.send(null);
        return xmlHttp.responseText;
    }
}

dss.ajaxAssyncRequestWithoutAnswer = function(surl, params, callback) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?"

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        if (callback != null)
            xmlHttp.onreadystatechange = function() {
                if (xmlHttp.readyState == 4)
                    callback(xmlHttp.responseText);
            };
        xmlHttp.open('GET', surl + paramString, true);
        xmlHttp.send(null);
    }
}

dss.raiseEvent = function(name, params) {
    var sURL = '/json/event/raise';
    var paramString = "";
    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + ";";
    }
    dss.ajaxAssyncRequestWithoutAnswer(sURL, {
        'name' : name,
        'parameter' : paramString.substr(0, paramString.length - 1)
    });
}

dss.staticDataModel = {};
dss.staticDataModel.baseImagePath = "framework/images/";
dss.staticDataModel.sQueryStringDevices = "/apartment/zones/zone0/devices/*(*)/*(*)/*(*)";
dss.staticDataModel.sQueryStringStructure = '/apartment/zones/*(ZoneID,name)/groups/*(group,name)/scenes/*(scene,name)';
dss.staticDataModel.sQueryStringHLE = '/usr/events/*(name,id)';
dss.staticDataModel.nameCache = null;
dss.staticDataModel.deviceCache = null;
dss.staticDataModel.HLECache = null;
dss.staticDataModel.deviceWithSensorsCache = null;

dss.staticDataModel.getHLENameFromId = function(id) {
    for ( var iIndex = 0; iIndex < dss.staticDataModel.HLECache.length; iIndex++) {
        if (dss.staticDataModel.HLECache[iIndex].id == id)
            return dss.staticDataModel.HLECache[iIndex].name;
    }
    return id;
}

dss.staticDataModel.initCaches = function() {
    dss.staticDataModel.initNameCache();
    dss.staticDataModel.initDeviceCache();
    dss.staticDataModel.initHLECache();
}

dss.staticDataModel.initNameCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringStructure
    });
    var resultObj = eval('(' + sResult + ')');
    if (resultObj.ok) {
        if (resultObj.result.zones != null) {
            dss.staticDataModel.nameCache = resultObj.result.zones;
        }
    }
}
dss.staticDataModel.initDeviceCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringDevices
    });
    var resultObj = eval('(' + sResult + ')');
    if (resultObj.ok) {
        dss.staticDataModel.deviceCache = [];
        dss.staticDataModel.deviceWithSensorsCache = [];
        if (resultObj.result.devices!=null) {
            for ( var iIndex = 0; iIndex < resultObj.result.devices.length; iIndex++) {
                var oDevObject = resultObj.result.devices[iIndex];
                var newObject = {
                    dSID : oDevObject.dSID,
                    name : oDevObject.name,
                    present : oDevObject.present,
                    functionID : oDevObject.functionID,
                    productID : oDevObject.productID,
                    outputMode : oDevObject.outputMode,
                    ZoneID : oDevObject.ZoneID,
                    DSMeterDSID : oDevObject.DSMeterDSID
                };
                var subObject = oDevObject[oDevObject.dSID];
                for ( var jIndex = 0; jIndex < subObject.length; jIndex++) {
                    if (subObject[jIndex].sensorEvents != null) {
                        newObject.sensorEvents = [];
                        for ( var sKey in subObject[jIndex]) {
                            if (sKey != 'sensorEvents')
                                newObject.sensorEvents.push(subObject[jIndex][sKey]);
                        }
                    }
                    if (subObject[jIndex].button != null) {
                        if (subObject[jIndex].id != null)
                            newObject.tasterMode = subObject[jIndex].id;
                        if (subObject[jIndex].groupMembership != null)
                            newObject.buttonGroupMembership = subObject[jIndex].groupMembership;
                        if (subObject[jIndex].activeGroup != null)
                            newObject.buttonActiveGroup = subObject[jIndex].activeGroup;
                        if (subObject[jIndex].setsLocalPriority != null)
                            newObject.buttonSetsLocalPriority = subObject[jIndex].setsLocalPriority;
                    }
                    if (subObject[jIndex].groups != null) {
                        if (subObject[jIndex].groups != null) {
                            for ( var kIndex = 0; kIndex < subObject[jIndex].groups.length; kIndex++)
                                if (subObject[jIndex].groups[kIndex] != 8) // standardgruppe fr ausfhrung ist niemals gruppe 8
                                    newObject.GroupID = subObject[jIndex].groups[kIndex].id;
                        }
                    }
                }
                if (newObject.name == "")
                    newObject.name = "(" + newObject.dSID.substring(16) + ")";
                newObject.icon = dss.staticDataModel.getImageForDevice(newObject);
                dss.staticDataModel.deviceCache.push(newObject);
                if (newObject.sensorEvents != null)
                    if (newObject.sensorEvents.length > 0)
                        dss.staticDataModel.deviceWithSensorsCache.push(newObject);
            }
        }
    }
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        var oZone = dss.staticDataModel.nameCache[iIndex];
        if (oZone.name == "") {
            if (oZone.ZoneID == 0)
                oZone.name = "Alle R&auml;ume";
            else
                oZone.name = "Raum #" + oZone.ZoneID;
        }
        for ( var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
            var oGroup = oZone.groups[jIndex];
            oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
            oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
            oGroup.reachable = false;
            if (oGroup.group == 0)
                oGroup.reachable = true;
            for ( var iDeviceIndex = 0; iDeviceIndex < dss.staticDataModel.deviceCache.length; iDeviceIndex++)
                if ((dss.staticDataModel.deviceCache[iDeviceIndex].ZoneID == oZone.ZoneID) || (oZone.ZoneID == 0))
                    if (dss.staticDataModel.deviceCache[iDeviceIndex].buttonActiveGroup == oGroup.group)
                        oGroup.reachable = true;
        }
    }
}

dss.staticDataModel.initHLECache = function() {
    dss.staticDataModel.HLECache = [];
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringHLE
    });
    var resultObj = eval('(' + sResult + ')');
    if (resultObj.ok) {
        if (resultObj.result.events != null)
            dss.staticDataModel.HLECache = resultObj.result.events;
    }
}

dss.staticDataModel.getHLE = function() {
    if (dss.staticDataModel.HLECache == null)
        dss.staticDataModel.initHLECache();
    return dss.staticDataModel.HLECache;
}

dss.staticDataModel.getSensorDeviceArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return dss.staticDataModel.deviceWithSensorsCache;
}

dss.staticDataModel.getZoneArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();

    var oResult = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        oResult.push({
            ZoneID : dss.staticDataModel.nameCache[iIndex].ZoneID,
            name : dss.staticDataModel.nameCache[iIndex].name
        });
    }
    return oResult;
}

dss.staticDataModel.getDevicesForZone = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oRetArray = [];
    for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
        var oDeviceObject = dss.staticDataModel.deviceCache[i];
        var oDeviceGroup=oDeviceObject.GroupID;
        if (oDeviceGroup==8)
            oDeviceGroup=oDeviceObject.buttonActiveGroup;
        if ((oDeviceObject.ZoneID == zoneID) || (zoneID == 0))
            if ((oDeviceGroup == groupID) || (groupID == 0))
                oRetArray.push(oDeviceObject);
    }
    return oRetArray;
}

dss.staticDataModel.getNameForGroup = function(zoneID, group) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var defaultName = "Gruppe " + group + " ";
    var baseName = "";

    switch (group) {
        case 0:
            defaultName = 'Alle Gruppen';
            baseName = 'broadcast';
        break;
        case 1:
            defaultName = 'Licht';
            baseName = 'yellow'
        break;
        case 2:
            defaultName = 'Schatten';
            baseName = 'gray';
        break;
        case 3:
            defaultName = 'Klima';
            baseName = 'blue';
        break;
        case 4:
            defaultName = 'Audio';
            baseName = 'cyan';
        break;
        case 5:
            defaultName = 'Video';
            baseName = 'magenta';
        break;
        case 6:
            defaultName = 'Sicherheit';
            baseName = 'red';
        break;
        case 7:
            defaultName = 'Zugang';
            baseName = 'green';
        break;
        case 8:
            defaultName = 'Joker';
            baseName = 'black';
        break;
        case 9:
            defaultName = 'Custom';
            baseName = 'white';
        break;
        case 10:
            defaultName = 'Anzeige';
            baseName = 'display';
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group)
                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name != baseName)
                        return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name;
    return defaultName;
}

dss.staticDataModel.getDefaultNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var defaultName = "Stimmung Nr. " + scene;

    switch (scene) {
        case 67:
            defaultName = 'Standby';
        break;
        case 64:
            defaultName = 'Auto Standby';
        break;
        case 68:
            defaultName = 'Deep Off';
        break;
        case 69:
            defaultName = 'Schlafen';
        break;
        case 70:
            defaultName = 'Aufwachen';
        break;
        case 72:
            defaultName = 'Gehen';
        break;
        case 71:
            defaultName = 'Kommen';
        break;
        case 73:
            defaultName = 'Klingel';
        break;
        case 65:
            defaultName = 'Panik';
        break;
        case 0:
            if (group == 2)
                defaultName = 'Zu';
            else
                defaultName = 'Aus';
        break;
        case 5:
            if (group == 2)
                defaultName = 'Auf';
            else
                defaultName = 'Stimmung 1';
        break;
        case 17:
            defaultName = 'Stimmung 2';
        break;
        case 18:
            defaultName = 'Stimmung 3';
        break;
        case 19:
            defaultName = 'Stimmung 4';
        break;
        case 1:
            if (group == 2)
                defaultName = 'Bereich 1 zu';
            else
                defaultName = 'Bereich 1 aus';
        break;
        case 6:
            if (group == 2)
                defaultName = 'Bereich 1 auf';
            else
                defaultName = 'Bereich 1 ein';
        break;
        case 2:
            if (group == 2)
                defaultName = 'Bereich 2 zu';
            else
                defaultName = 'Bereich 2 aus';
        break;
        case 7:
            if (group == 2)
                defaultName = 'Bereich 2 auf';
            else
                defaultName = 'Bereich 2 ein';
        break;
        case 3:
            if (group == 2)
                defaultName = 'Bereich 3 zu';
            else
                defaultName = 'Bereich 3 aus';
        break;
        case 8:
            if (group == 2)
                defaultName = 'Bereich 3 auf';
            else
                defaultName = 'Bereich 3 ein';
        break;
        case 4:
            if (group == 2)
                defaultName = 'Bereich 4 zu';
            else
                defaultName = 'Bereich 4 aus';
        break;
        case 9:
            if (group == 2)
                defaultName = 'Bereich 4 auf';
            else
                defaultName = 'Bereich 4 ein';
        break;
        case 32:
            defaultName = 'Stimmung 10';
        break;
        case 33:
            defaultName = 'Stimmung 11';
        break;
        case 34:
            defaultName = 'Stimmung 20';
        break;
        case 35:
            defaultName = 'Stimmung 21';
        break;
        case 36:
            defaultName = 'Stimmung 30';
        break;
        case 37:
            defaultName = 'Stimmung 31';
        break;
        case 38:
            defaultName = 'Stimmung 40';
        break;
        case 39:
            defaultName = 'Stimmung 41';
        break;
        case 20:
            defaultName = 'Stimmung 12';
        break;
        case 21:
            defaultName = 'Stimmung 13';
        break;
        case 22:
            defaultName = 'Stimmung 14';
        break;
        case 23:
            defaultName = 'Stimmung 22';
        break;
        case 24:
            defaultName = 'Stimmung 23';
        break;
        case 25:
            defaultName = 'Stimmung 24';
        break;
        case 26:
            defaultName = 'Stimmung 32';
        break;
        case 27:
            defaultName = 'Stimmung 33';
        break;
        case 28:
            defaultName = 'Stimmung 34';
        break;
        case 29:
            defaultName = 'Stimmung 42';
        break;
        case 30:
            defaultName = 'Stimmung 43';
        break;
        case 31:
            defaultName = 'Stimmung 44';
        break;
    }
    return defaultName;
}

dss.staticDataModel.getNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = "";

    switch (scene) {
        case 67:
            baseName = 'STANDBY'
        break;
        case 64:
            baseName = 'AUTO_STANDBY'
        break;
        case 68:
            baseName = 'DEEP_OFF'
        break;
        case 69:
            baseName = 'SLEEPING'
        break;
        case 70:
            baseName = 'WAKE_UP'
        break;
        case 72:
            baseName = 'ABSENT'
        break;
        case 71:
            baseName = 'PRESENT'
        break;
        case 73:
            baseName = 'SIG_BELL'
        break;
        case 65:
            baseName = 'PANIC'
        break;
        case 0:
            baseName = 'T0_S0'
        break;
        case 5:
            baseName = 'T0_S1'
        break;
        case 17:
            baseName = 'T0_S2'
        break;
        case 18:
            baseName = 'T0_S3'
        break;
        case 19:
            baseName = 'T0_S4'
        break;
        case 1:
            baseName = 'T1_S0'
        break;
        case 6:
            baseName = 'T1_S1'
        break;
        case 2:
            baseName = 'T2_S0'
        break;
        case 7:
            baseName = 'T2_S1'
        break;
        case 3:
            baseName = 'T3_S0'
        break;
        case 8:
            baseName = 'T3_S1'
        break;
        case 4:
            baseName = 'T4_S0'
        break;
        case 9:
            baseName = 'T4_S1'
        break;
        case 32:
            baseName = 'T1E_S0'
        break;
        case 33:
            baseName = 'T1E_S1'
        break;
        case 34:
            baseName = 'T2E_S0'
        break;
        case 35:
            baseName = 'T2E_S1'
        break;
        case 36:
            baseName = 'T3E_S0'
        break;
        case 37:
            baseName = 'T3E_S1'
        break;
        case 38:
            baseName = 'T4E_S0'
        break;
        case 39:
            baseName = 'T4E_S1'
        break;
        case 20:
            baseName = 'T1_S2'
        break;
        case 21:
            baseName = 'T1_S3'
        break;
        case 22:
            baseName = 'T1_S4'
        break;
        case 23:
            baseName = 'T2_S2'
        break;
        case 24:
            baseName = 'T2_S3'
        break;
        case 25:
            baseName = 'T2_S4'
        break;
        case 26:
            baseName = 'T3_S2'
        break;
        case 27:
            baseName = 'T3_S3'
        break;
        case 28:
            baseName = 'T3_S4'
        break;
        case 29:
            baseName = 'T4_S2'
        break;
        case 30:
            baseName = 'T4_S3'
        break;
        case 31:
            baseName = 'T4_S4'
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group)
                    for ( var iSceneIndex = 0; iSceneIndex < dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes.length; iSceneIndex++)
                        if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].scene == scene)
                            if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != null)
                                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != '')
                                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != baseName)
                                        return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name;
    return dss.staticDataModel.getDefaultNameForScene(zoneID, group, scene);
}

dss.staticDataModel.getNameForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = "Raum #" + zoneID;
    if (zoneID == 0)
        baseName = "ganze Installation";
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            if (dss.staticDataModel.nameCache[iZoneIndex].name != "")
                return dss.staticDataModel.nameCache[iZoneIndex].name;
    return baseName;
}

dss.staticDataModel.getGroupForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID) {
            var oResult = [];
            for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iIndex++)
                oResult.push({
                    'group' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group,
                    'name' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].name,
                    'icon' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].icon,
                    'reachable' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].reachable
                });
            return oResult;
        }
    return null;
}

dss.staticDataModel.getDevice = function(deviceID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
        if (deviceID == dss.staticDataModel.deviceCache[i].dSID)
            return dss.staticDataModel.deviceCache[i];
    }
    return {
        dSID : deviceID,
        name : "",
        functionID : 0x1000
    };
}

dss.staticDataModel.getImagePathForScene = function(zoneID, groupID, sceneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_1";
    switch (groupID) {
        case 1:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_1";
        break;
        case 2:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_2";
            if (sceneID == 5)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 6)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 7)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 8)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 9)
                return baseGroupName + '_scene_5.png';
        break;
        case 3:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_3";
        break;
        case 4:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_4";
        break;
        case 5:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_5";
        break;
        case 6:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_6";
        break;
        case 7:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/group_7";
        break;
    }
    switch (sceneID) {
        case 0:
        case 1:
        case 2:
        case 3:
        case 4:
        case 32:
        case 34:
        case 36:
        case 38:
            return baseGroupName + '_deact.png';
        break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
        case 17:
        case 18:
        case 19:
        case 20:
        case 21:
        case 22:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 28:
        case 29:
        case 30:
        case 31:
        case 33:
        case 35:
        case 37:
        case 39:
            return baseGroupName + '_active.png';
        break;
        case 15:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_stop.png';
        break;
        case 64:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_standby.png';
        break;
        case 65:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_panic.png';
        break;
        case 67:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_standby.png';
        break;
        case 68:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_deep_off.png';
        break;
        case 69:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_sleeping.png';
        break;
        case 70:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_wakeup.png';
        break;
        case 71:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_present.png';
        break;
        case 72:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_absent.png';
        break;
        case 73:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/scene_bell.png';
        break;
    }
}

dss.staticDataModel.getScenes = function(zoneId, groupId) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oDeviceArray = dss.staticDataModel.getDevicesForZone(zoneId, groupId);

    var oRetArray = [];
    var sceneArray = [ 0, 5, 17, 18, 19, 1, 6, 2, 7, 3, 8, 4, 9, 32, 33, 34, 35, 36, 37, 38, 39, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 67,
            64, 68, 69, 70, 72, 71, 73, 65 ];
    for ( var iIndex = 0; iIndex < sceneArray.length; iIndex++) {
        var oSzeneObject = {
            id : sceneArray[iIndex],
            groupID : groupId,
            zoneID : zoneId,
            reachable : false
        };
        oSzeneObject.name = dss.staticDataModel.getNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.defaultName = dss.staticDataModel.getDefaultNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.icon = dss.staticDataModel.getImagePathForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oRetArray.push(oSzeneObject);
    }

    function searchAndEnableScene(id) {
        for ( var iIndex = 0; iIndex < oRetArray.length; iIndex++)
            if (oRetArray[iIndex].id == id)
                oRetArray[iIndex].reachable = true;
    }

    if (groupId != 0)
        for ( var iDeviceIndex = 0; iDeviceIndex < oDeviceArray.length; iDeviceIndex++) {
            var oDev = oDeviceArray[iDeviceIndex];
            switch (oDev.tasterMode) {
                case 0:
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                    searchAndEnableScene(0);
                break;
                case 1:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 2:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 3:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 4:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 5:
                    searchAndEnableScene(0);
                    searchAndEnableScene(5);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 6:
                    searchAndEnableScene(32);
                    searchAndEnableScene(33);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 7:
                    searchAndEnableScene(34);
                    searchAndEnableScene(35);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 8:
                    searchAndEnableScene(36);
                    searchAndEnableScene(37);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 9:
                    searchAndEnableScene(38);
                    searchAndEnableScene(39);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
                case 10:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 11:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 12:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 13:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
            }
        }

    if ((zoneId != 0) && (groupId == 0)) {
        searchAndEnableScene(67);
        searchAndEnableScene(68);
        searchAndEnableScene(69);
        searchAndEnableScene(70);
    }

    if ((zoneId == 0) && (groupId == 0))
        for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
            var oDeviceObject = dss.staticDataModel.deviceCache[i];
            if (oDeviceObject.functionID == 0x7010)
                searchAndEnableScene(73); // klingel
            if (oDeviceObject.functionID == 0x6001)
                searchAndEnableScene(65); // panik
            if (oDeviceObject.functionID == 0x7050) {
                searchAndEnableScene(71); // kommen
                searchAndEnableScene(72); // gehen
            }
        }

    return oRetArray;
}

dss.staticDataModel.getImagePathForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    switch (groupID) {
        case 0:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_0.png';
        break;
        case 1:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_1.png';
        break;
        case 2:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_2.png';
        break;
        case 3:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_3.png';
        break;
        case 4:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_4.png';
        break;
        case 5:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_5.png';
        break;
        case 6:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_6.png';
        break;
        case 7:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_7.png';
        break;
        case 8:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_8.png';
        break;
        case 9:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_9.png';
        break;
        case 10:
            return dss.staticDataModel.baseImagePath + 't.gif';
        break;
    }
}

dss.staticDataModel.getImageForScene = function(zoneID, groupID, sceneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return '<img src="' + dss.staticDataModel.getImagePathForScene(zoneID, groupID, sceneID) + '" alt="'
            + dss.staticDataModel.getNameForScene(zoneID, groupID, sceneID) + '">';
}

dss.staticDataModel.getImageForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return '<img src="' + dss.staticDataModel.getImagePathForGroup(zoneID, groupID) + '" alt="'
            + dss.staticDataModel.getNameForGroup(zoneID, groupID) + '">';

}

dss.staticDataModel.getImageForDevice = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var sIcon = "default/star_white";
    var fBlackPossible = false;
    var fBlackBlackPossible = false;
    switch ((device.productID >> 10) & 0x3f) {
        case 0:
            sIcon = "km/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 1:
            sIcon = "tkm/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 2:
            sIcon = "sdm/";
            fBlackPossible = true;
        break;
        case 3:
            sIcon = "kl/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 4:
            sIcon = "tkm/";
            fBlackPossible = true;
        break;
        case 5:
            sIcon = "zws/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 6:
            sIcon = "sds/";
            fBlackPossible = true;
        break;

    }

    switch ((device.functionID & 0xf000) >> 12) {
        case 1:
            sIcon += "yellow";
        break;
        case 2:
            sIcon += "grey";
        break;
        case 3:
            sIcon += "blue";
        break;
        case 4:
            sIcon += "cyan";
        break;
        case 5:
            sIcon += "magenta";
        break;
        case 6:
            sIcon += "red";
        break;
        case 7:
            sIcon += "green";
        break;
        case 8:
            sIcon += "black";
            if (fBlackPossible) {
                if (device.buttonActiveGroup == 1)
                    sIcon += "_yellow";
                if (device.buttonActiveGroup == 2)
                    sIcon += "_grey";
                if (device.buttonActiveGroup == 3)
                    sIcon += "_blue";
                if (device.buttonActiveGroup == 4)
                    sIcon += "_cyan";
                if (device.buttonActiveGroup == 5)
                    sIcon += "_magenta";
                if (device.buttonActiveGroup == 6)
                    sIcon += "_red";
                if (device.buttonActiveGroup == 7)
                    sIcon += "_green";
                if (fBlackBlackPossible)
                    if (device.buttonActiveGroup == 8)
                        sIcon += "_black";
            }
        break;
        default:
            sIcon = "default/star_white";
        break;
    }
    return dss.staticDataModel.baseImagePath + "deviceIcons/" + sIcon + ".png"
}

/*
 * oJsonObject: Typical dss-Answer Object paramDef: array of expected Objects in AnswerArray { name: properyName, type: simple|action|trigger|condition/enabled }
 */
dss.parsePropertyQueryAnswer = function(oJsonObject, paramDef) {
    if (oJsonObject.ok == null)
        return null;
    if (!oJsonObject.ok)
        return null;
    if (oJsonObject.result == null)
        return null;
    var oReturnArray = [];
    for ( var sKey in oJsonObject.result) {
        var oRootArray = oJsonObject.result[sKey];
        for ( var iIndex = 0; iIndex < oRootArray.length; iIndex++) {
            var oObject = {};
            var oIteratorObject = oRootArray[iIndex];
            for ( var sIndex = 0; sIndex < paramDef.length; sIndex++) {
                var oKeyParameter = paramDef[sIndex].name;

                if (paramDef[sIndex].type == 'simple') {
                    if (oIteratorObject[oKeyParameter] != null)
                        oObject[oKeyParameter] = oIteratorObject[oKeyParameter];
                    else
                        oObject[oKeyParameter] = null;
                } else if ((paramDef[sIndex].type == 'action') || (paramDef[sIndex].type == 'trigger')) {
                    oObject[oKeyParameter] = [];
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject[oKeyParameter] != null) {

                                    for ( var kIndex = 0; kIndex < oArrayObject[oKeyParameter].length; kIndex++) {
                                        var resultObject = oArrayObject[oKeyParameter][kIndex];
                                        var oActionObject = {};
                                        for ( var oKey in resultObject) {
                                            oActionObject[oKey] = resultObject[oKey];
                                        }
                                        oObject[oKeyParameter].push(oActionObject);
                                    }

                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'condition/enabled')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.conditions != null)
                                    if (oArrayObject.enabled != null)
                                        oObject[oKeyParameter] = !oArrayObject.enabled;
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'message')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.message != null) {
                                    oObject[oKeyParameter] = {};
                                    oObject[oKeyParameter].messageType = oArrayObject.messageType;
                                    oObject[oKeyParameter].receiver = oArrayObject.receiver;
                                    oObject[oKeyParameter].subject = oArrayObject.subject;
                                    oObject[oKeyParameter].message = oArrayObject.messageBody;
                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'recurrence')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.recurrenceBase != null)
                                    oTimeObject.recurrenceBase = oArrayObject.recurrenceBase;
                                if (oArrayObject.time != null) {
                                    oTimeObject.timeArray = [];
                                    for ( var oKey in oArrayObject.time) {
                                        var oSubArray = oArrayObject.time[oKey]
                                        for ( var aKey in oSubArray) {
                                            if (oSubArray[aKey] != null)
                                                oTimeObject.timeArray.push(oSubArray[aKey]);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                } else if ((paramDef[sIndex].type == 'time')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.timeBase != null)
                                    oTimeObject.timeBase = oArrayObject.timeBase;
                                if (oArrayObject.offset != null)
                                    oTimeObject.offset = oArrayObject.offset;
                                if (oArrayObject.limitBefore != null)
                                    oTimeObject.limitBefore = oArrayObject.limitBefore;
                                if (oArrayObject.limitAfter != null)
                                    oTimeObject.limitAfter = oArrayObject.limitAfter;
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                }
            }
            oReturnArray.push(oObject);
        }

    }
    return oReturnArray;
}
